/* @(#) $Id: client.h,v 1.8 2004/08/04 01:31:03 leres Exp $ (LBL) */
#ifndef acld_client_h
#define acld_client_h

struct client {
	struct client *next;
	u_int n;			/* client number */
	int c;				/* client socket */
	int close;			/* finish writing and then close */
	struct iobuf rbuf;		/* read buffer */
	struct iobuf wbuf;		/* write buffer */
	struct req *treq;		/* partially built request */
	struct req *req;		/* request list */
};

extern struct s2v cmd2req[];

#define CS_CONTINUE	0x1
#define CS_FAILED	0x2


#ifdef __STDC__
struct state;
#endif

void clientinput(struct state *, struct client *);
void clientprocess(struct state *, struct client *, struct req *);
void clientsend(struct state *, struct client *, struct req *, int);
void clientsendeom(struct state *, struct client *);
void clientsenderr(struct state *, struct client *, struct req *,
    const char *, ...) __attribute__ ((format (printf, 4, 5)));
void clientwrite(struct state *, struct client *, const char *, ...)
    __attribute__ ((format (printf, 3, 4)));
void clientwriteraw(struct state *, struct client *, const char *);
void freeclient(struct state *, struct client *);
struct client *newclient(struct state *, int);
#endif
