/* @(#) $Id: util.h,v 1.6 2004/09/13 17:49:55 leres Exp $ (LBL) */
#ifndef acld_util_h
#define acld_util_h

struct s2v {
	const char *s;
	int v;
};

struct v2v {
	int	v1;
	int	v2;
};

extern struct s2v syslog2str[];

char *addr2str(u_int32_t);
void dynarray(void **, int *, int *, size_t, int, int, const char *);
const char *escapestr(const char *);
const char *extractaddr(const char *, const char *, struct addr *);
void freeargv(char **);
void freedynarray(void **, int *, int *);
void getts(struct timeval *);
#ifndef HAVE_INET_ATON
#ifdef __STDC__
struct in_addr;
#endif
int inet_aton(const char *, struct in_addr *);
#endif
void log(int, const char *, ...)
    __attribute__ ((format (printf, 2, 3)));
int makeargv(const char *, char ***);
int maskwidth(u_int32_t);
void *new(size_t, size_t, const char *);
const char *pretty(const char *, ssize_t);
const char *simplewd(void);
int str2val(const struct s2v *, const char *);
int str2valcase(const struct s2v *, const char *);
void strappend(char **, const char *);
char *strsave(const char *);
int suck2dot(FILE *, char **);
void trimws(char *);
const char * tsstr(void);
int typ2flag(const struct v2v *, int);
const char *val2str(const struct s2v *, int);
#endif
